//Example program demonstrating the join operation
#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include "ffdb_util.h"
#include <stdio.h>

using namespace ffdb;

int main(void) {
	RowSet rowset_user;
	if(!ReadFromFile("example_db_user.ffdb",&rowset_user)) {
		fprintf(stderr,"Could not read from user database\n");
		return -1;
	}
	
	RowSet rowset_quota;
	if(!ReadFromFile("example_db_quota.ffdb",&rowset_quota)) {
		fprintf(stderr,"Could not read from quota database\n");
		return -1;
	}
	
	//first find the user
	PreparedSelection prep_sel;
	int cond_idx = prep_sel.add_condition("username",cond_eq);
	prep_sel.set_value(cond_idx,"johnny");
	
	RowSet result1;
	if(!prep_sel.execute(rowset_user,&result1)) {
		fprintf(stderr,"Could not select from user database\n");
		return -1;
	}
	
	//now join with quota
	RowSet result2;
	Join(result1,rowset_quota,&result2,"id","userid",0);
	
	printf("Johnny's quotas:\n");
	dump(result2,stdout);
	
	return 0;
}
