//Example program demonstratnig miscellaneous operations
#include "ffdb.h"
#include "ffdb_io.h"
#include <stdio.h>

using namespace ffdb;

int main(void) {
	RowSet rowset_user;
	if(!ReadFromFile("example_db_user.ffdb",&rowset_user)) {
		fprintf(stderr,"Could not read from user database\n");
		return -1;
	}
	
	printf("There are %ld users in the database\n", (long)rowset_user.size());
	
	const RowSetDescriptor &desc = rowset_user.descriptor();
	printf("Table layout (%ld columns):\n",(long)desc.size());
	for(RowSetDescriptor::const_iterator iter=desc.begin();
	    iter!=desc.end();
	    iter++)
	{
		printf("  %s : ", iter->name.c_str());
		switch(iter->type) {
			case ColumnType_integer:
				printf("integer"); break;
			case ColumnType_real:
				printf("real"); break;
			case ColumnType_string:
				printf("string"); break;
			case ColumnType_raw:
				printf("raw"); break;
			case ColumnType_boolean:
				printf("boolean"); break;
			default:
				printf("unknown"); break;
		}
		printf("\n");
	}
	
	size_t total_row_size=0;
	for(RowSet::const_iterator iter=rowset_user.begin();
	    iter!=rowset_user.end();
	    iter++)
		total_row_size += iter->raw_size();
	printf("Average row size (%ld/%ld) = %ld bytes\n",
	       (long)total_row_size,
	       (long)rowset_user.size(),
	       (long)(total_row_size/rowset_user.size())
	       );
	
	return 0;
}
