//Example program demonstating simplified field access
//You can also use the [] operator on Row and convert
//the values yourself (which are guaranteed to be correctly aligned)
#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_row_access.h"
#include <stdio.h>

using namespace ffdb;

int main(void) {
	RowSet rowset_user;
	if(!ReadFromFile("example_db_user.ffdb",&rowset_user)) {
		fprintf(stderr,"Could not read from user database\n");
		return -1;
	}
	
	printf("There are %ld users in the database\n", (long)rowset_user.size());
	
	const RowSetDescriptor &desc = rowset_user.descriptor();
	for(RowSet::const_iterator iter=rowset_user.begin();
	    iter!=rowset_user.end();
	    iter++)
	{
		printf("record %u: id=%d username=%s\n",
		       (unsigned)(iter-rowset_user.begin()),
		       (int)getInteger(desc,iter,"id"),
		       getString(desc,iter,"username")
		      );
	}
	return 0;
}
