#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include <stdio.h>

using namespace ffdb;

int main(int argc, char **argv) {
	if(argc!=2) {
		fprintf(stderr,"usage error\n");
		return -1;
	}
	RowSet rowset;
	if(!ReadFromFile(argv[1],&rowset)) {
		fprintf(stderr,"Could not read from test file\n");
		return -1;
	}

	PreparedSelection prep_sel;
	prep_sel.add_condition("ispvn_id",cond_eq);
	prep_sel.add_condition("username",cond_eq);
	
	
	for(int i=0; i<100; i++) {
		RowSet result;
		prep_sel.set_value(0,(int64_t)1);
		prep_sel.set_value(1,"username50088");
		if(!prep_sel.execute(rowset,&result) || result.size()!=1) {
			fprintf(stderr,"execute error\n");
			return -1;
		}
	}
	return 0;
}
