#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include <stdio.h>
#include <string.h>

using namespace ffdb;

int main(int argc, char **argv) {
	if(argc<5) {
		fprintf(stderr,"usage error\n");
		return -1;
	}
	RowSet rowset1;
	if(!ReadFromFile(argv[1],&rowset1)) {
		printf("Could not load DB\n");
		return -1;
	}
	RowSet rowset2;
	if(!ReadFromFile(argv[2],&rowset2)) {
		printf("Could not load DB\n");
		return -1;
	}
	
	
	bool outer=strcmp(argv[4],"true")==0;
	
	PreparedJoin prep_join;
	for(int i=5; i<argc; i+=2) {
		prep_join.add_relation(argv[i],argv[i+1]);
	}
	
	RowSet result_rowset;
	if(!prep_join.execute(rowset1,rowset2,&result_rowset,outer)) {
		fprintf(stderr,"Join error\n");
		return -1;
	}
	if(!WriteToFile(argv[3],result_rowset)) {
		fprintf(stderr,"Could not write to result file\n");
		return -1;
	}
	return 0;
}
