#include "ffdb.h"
#include "ffdb_io.h"
#include "ffdb_op.h"
#include <stdio.h>

using namespace ffdb;

int main(int argc, char **argv) {
	if(argc<3) {
		fprintf(stderr,"usage error\n");
		return -1;
	}
	RowSet source_rowset;
	if(!ReadFromFile(argv[1],&source_rowset)) {
		printf("Could not load DB\n");
		return -1;
	}
	
	PreparedProjection prep_proj;
	for(int i=3; i<argc; i++)
		prep_proj.add_column(argv[i]);
	
	RowSet result_rowset;
	if(!prep_proj.execute(source_rowset,&result_rowset)) {
		fprintf(stderr,"Project error\n");
		return -1;
	}
	if(!WriteToFile(argv[2],result_rowset)) {
		fprintf(stderr,"Could not write to test file\n");
		return -1;
	}
	return 0;
}
